Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::Drummer Class Reference

STK drum sample player class. More...

`#include <Drummer.h>`

Inheritance diagram for stk::Drummer:

List of all members.

## Public Member Functions
| Drummer (void)
| Class constructor.
| ~Drummer (void)
| Class destructor.
void | noteOn (StkFloat instrument, StkFloat amplitude)
| Start a note with the given drum type and amplitude.
void | noteOff (StkFloat amplitude)
| Stop a note with the given amplitude (speed of decay).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

STK drum sample player class.

This class implements a drum sampling synthesizer using WvIn objects and one-pole filters. The drum rawwave files are sampled at 22050 Hz, but will be appropriately interpolated for other sample rates. You can specify the maximum polyphony (maximum number of simultaneous voices) via a define in the Drummer.h.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::Drummer::Drummer | ( | void |  | ) |

Class constructor.

An StkError will be thrown if the rawwave path is incorrectly set.

## Member Function Documentation

void stk::Drummer::noteOn | ( | StkFloat | instrument,
|  | StkFloat | amplitude |
| ) |  |  | `[virtual]`

Start a note with the given drum type and amplitude.

Use general MIDI drum instrument numbers, converted to frequency values as if MIDI note numbers, to select a particular instrument. An StkError will be thrown if the rawwave path is incorrectly set.

Implements stk::Instrmnt.

StkFrames & stk::Drummer::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Instrmnt.

    00101 {
    00102   unsigned int nChannels = lastFrame_.channels();
    00103 #if defined(_STK_DEBUG_)
    00104   if ( channel > frames.channels() - nChannels ) {
    00105     oStream_ << "Drummer::tick(): channel and StkFrames arguments are incompatible!";
    00106     handleError( StkError::FUNCTION_ARGUMENT );
    00107   }
    00108 #endif
    00109
    00110   StkFloat *samples = &frames[channel];
    00111   unsigned int j, hop = frames.channels() - nChannels;
    00112   if ( nChannels == 1 ) {
    00113     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00114       *samples++ = tick();
    00115   }
    00116   else {
    00117     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00118       *samples++ = tick();
    00119       for ( j=1; j<nChannels; j++ )
    00120         *samples++ = lastFrame_[j];
    00121     }
    00122   }
    00123
    00124   return frames;
    00125 }

The documentation for this class was generated from the following file:

- Drummer.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.